#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_demo1_mp_xi4.py">
#<verify4xi verification = "10" target = "queue4xi.py"/>
#<contextualize4xi context = "process4xi.py"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# standard Imports                              
# -------------------------------------------------------------------------------------------------
import os
import sys


# -------------------------------------------------------------------------------------------------
# multiprocessing imports                              
# -------------------------------------------------------------------------------------------------
#from multiprocessing import Process, Queue <--- original, the following show modules used
from multiprocessing.queues import Queue
from multiprocessing.process import Process

# -------------------------------------------------------------------------------------------------
# yourDragonXi imports                               
# -------------------------------------------------------------------------------------------------
from process2xi import Process2Xi
from queue2xi import Queue2Xi


# -------------------------------------------------------------------------------------------------
#<function4xi function = "sense" usage = "sense">                      
# -------------------------------------------------------------------------------------------------  
def sense(target_para, queue_para):
    target_xi2 = target_para
    queue_xi2 = queue_para
    
    print("yourDragonXi SENSE: ", target_xi2)
    queue_xi2.put(['DragonXi2', target_xi2, 'SENSED !']) # puts to its queue
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "reason" usage = "reason">                      
# ------------------------------------------------------------------------------------------------- 
def reason(target_para, queue_para):
    target_xi4 = target_para
    queue_xi4 = queue_para
    
    print("yourDragonXi REASON: ", target_xi4)
    queue_xi4.put(['DragonXi4', target_xi4, 'REASONED !']) # puts to its queue 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "ace" usage = "ace">                      
# ------------------------------------------------------------------------------------------------- 
def ace(target_para, queue_para):
    target_xi8 = target_para
    queue_xi8 = queue_para
    
    print("yourDragonXi ACE: ", target_xi8)
    queue_xi8.put(['DragonXi8', target_xi8, 'ACED !']) # puts to its queue       
#</function4xi> 

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase1" usage = "phase1">                      
# ------------------------------------------------------------------------------------------------- 
def phase1():

    # =================================================================================================
    # PHASE I
    # =================================================================================================
    print("\n~~~~~~~~original multiprocessing ~~~~~~~~~~~~~~~~")
    # ---------------------------------------------------------------------------------------------
    # create queues for processes, when a function is defined to a process, the queue is the function parameter
    # ---------------------------------------------------------------------------------------------
    q2xi = Queue()
    q4xi = Queue()
    q8xi = Queue()

    # ---------------------------------------------------------------------------------------------
    # Phases with processes    
    # step 1: create a process object by defining the function and its parameters
    # step 2: start the process
    # step 3: get result from the process queue, where process function has put data
    # step 4: block the calling thread until the process whose join() method is called terminates (no timeout defined)    

    #
    # ---------------------------------------------------------------------------------------------
    # sense process with sense function   
    # ---------------------------------------------------------------------------------------------
    p2xi = Process(target=sense, args=('Energy',q2xi))
    p2xi.start()
    print (q2xi.get())
    print("yourDragonXi p2xi process started, its alive status: ",p2xi.is_alive())
    p2xi.join()
    
    # ---------------------------------------------------------------------------------------------
    # reason process with reason function
    # ---------------------------------------------------------------------------------------------
    print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
    p4xi = Process(target=reason, args=('Renewable Energy is HOT!',q4xi))
    p4xi.start()
    print (q4xi.get())
    print("yourDragonXi p4xi process started, its alive status: ",p4xi.is_alive())
    p4xi.join()
    
    # ---------------------------------------------------------------------------------------------
    # ace process with ace function    
    # ---------------------------------------------------------------------------------------------
    print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
    p8xi = Process(target=ace, args=('Invest to Solar Wind and BIO Energy!',q8xi))
    p8xi.start()
    print (q8xi.get())
    print("yourDragonXi p8xi process started, its alive status: ",p8xi.is_alive())
    p8xi.join()
    
    print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")    
#</function4xi>     
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase2" usage = "phase2">                      
# ------------------------------------------------------------------------------------------------- 
def phase2():  
    # =================================================================================================
    # PHASE II 
    # =================================================================================================
    print("\n~~~~~~~ Hyprid Dragonized Modules ~~~~~~~~~~~~~~~~~~")
    # ---------------------------------------------------------------------------------------------
    # create queues for processes, when a function is defined to a process, the queue is the function parameter
    # ---------------------------------------------------------------------------------------------
    q2xi = Queue2Xi()
    q4xi = Queue2Xi()
    q8xi = Queue2Xi()

    # ---------------------------------------------------------------------------------------------
    # Phases with processes    
    # step 1: create a process object by defining the function and its parameters
    # step 2: start the process
    # step 3: get result from the process queue, where process function has put data
    # step 4: block the calling thread until the process whose join() method is called terminates (no timeout defined)    

    #
    # ---------------------------------------------------------------------------------------------
    # sense process with sense function   
    # ---------------------------------------------------------------------------------------------
    p2xi = Process2Xi(target=sense, args=('Energy',q2xi))
    p2xi.start()
    print (q2xi.get())
    print("yourDragonXi p2xi process started, its alive status: ",p2xi.is_alive())
    p2xi.join()
    
    # ---------------------------------------------------------------------------------------------
    # reason process with reason function
    # ---------------------------------------------------------------------------------------------
    print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
    p4xi = Process2Xi(target=reason, args=('Renewable Energy is HOT!',q4xi))
    p4xi.start()
    print (q4xi.get())
    print("yourDragonXi p4xi process started, its alive status: ",p4xi.is_alive())
    p4xi.join()
    
    # ---------------------------------------------------------------------------------------------
    # ace process with ace function    
    # ---------------------------------------------------------------------------------------------
    print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
    p8xi = Process2Xi(target=ace, args=('Invest to Solar Wind and BIO Energy!',q8xi))
    p8xi.start()
    print (q8xi.get())
    print("yourDragonXi p8xi process started, its alive status: ",p8xi.is_alive())
    p8xi.join()
    
    print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")    
#</function4xi> 
    
# -------------------------------------------------------------------------------------------------
# main                              
# -------------------------------------------------------------------------------------------------    
def main():
    phase1()
    phase2()
#</function4xi> 

            
# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()

#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_demo1_mp_xi4.txt
#  
#  yourDragonXi SENSE:  Energy
#  yourDragonXi REASON:  Renewable Energy is HOT!
#  yourDragonXi ACE:  Invest to Solar Wind and BIO Energy!
#  yourDragonXi SENSE:  Energy
#  yourDragonXi REASON:  Renewable Energy is HOT!
#  yourDragonXi ACE:  Invest to Solar Wind and BIO Energy!
#  
#  ~~~~~~~~original multiprocessing ~~~~~~~~~~~~~~~~
#  ['DragonXi2', 'Energy', 'SENSED !']
#  yourDragonXi p2xi process started, its alive status:  True
#  
#  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  ['DragonXi4', 'Renewable Energy is HOT!', 'REASONED !']
#  yourDragonXi p4xi process started, its alive status:  True
#  
#  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  ['DragonXi8', 'Invest to Solar Wind and BIO Energy!', 'ACED !']
#  yourDragonXi p8xi process started, its alive status:  True
#  
#  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  
#  ~~~~~~~ Hyprid Dragonized Modules ~~~~~~~~~~~~~~~~~~
#  ['DragonXi2', 'Energy', 'SENSED !']
#  yourDragonXi p2xi process started, its alive status:  True
#  
#  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  ['DragonXi4', 'Renewable Energy is HOT!', 'REASONED !']
#  yourDragonXi p4xi process started, its alive status:  True
#  
#  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  ['DragonXi8', 'Invest to Solar Wind and BIO Energy!', 'ACED !']
#  yourDragonXi p8xi process started, its alive status:  True
#  
#  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>